<script>
import Vue from 'vue';
import {
  IsMobileMixin,
  UseLiteVimeo,
  UseLocalizedVideoSubtitles,
} from '~/mixins';

export default Vue.extend({
  name: 'DemoModal',
  // v-if used in this component will break GTM tracking. Use v-show instead
  mixins: [IsMobileMixin, UseLiteVimeo, UseLocalizedVideoSubtitles],
  props: {
    visible: {
      type: Boolean,
      required: true,
      default: false,
    },
    data: {
      type: Object,
      required: true,
      default: null,
    },
  },
  data() {
    return {
      isFullScreen: false,
    };
  },
  watch: {
    visible(newValue) {
      if (newValue) {
        document.querySelector('body').classList.add('noScroll');
      } else {
        document.querySelector('body').classList.remove('noScroll');

        const video =
          this.$refs.videoSection.querySelector('iframe').contentWindow;
        if (video) {
          video.postMessage('{"method":"pause"}', '*'); // vimeo
          video.postMessage(
            '{"event":"command","func":"stopVideo","args":""}',
            '*',
          ); // youtube
        }
      }
    },
  },
  methods: {
    close() {
      this.$emit('close');
    },
    toggleFullScreen() {
      this.isFullScreen = !this.isFullScreen;
    },
  },
});
</script>
<template>
  <div class="modal__backdrop--light" @click.self="close">
    <div class="modal" :class="{ fullscreen: isFullScreen }">
      <header v-show="!isMobile" class="modal__header">
        <slot name="header"></slot>
        <div class="header-title">
          <SlpTypography variant="body1-bold">{{
            data.subtitle
          }}</SlpTypography>
        </div>
        <div class="header-logo">
          <SlpIcon
            v-show="!isMobile"
            name="gitlab"
            size="md"
            alt="GitLab Logo Tanuki"
            variant="marketing"
          ></SlpIcon>
        </div>
        <div class="header-buttons">
          <SlpButton
            class="cta-button"
            variant="primary"
            :href="data.scheduleButton.href"
            :data-ga-name="data.scheduleButton.data_ga_name"
            :data-ga-location="data.scheduleButton.data_ga_location"
            >{{ data.scheduleButton.text }}</SlpButton
          >
          <button
            v-show="!isMobile"
            type="button"
            class="btn btn__maximize"
            variant="secondary"
            @click="toggleFullScreen"
          >
            <SlpIcon name="maximize" variant="product" />
            <div class="popup-content">
              <p>Fullscreen</p>
              <div class="point"></div>
            </div>
          </button>
          <button
            v-show="!isMobile"
            type="button"
            class="btn btn__minimize"
            variant="secondary"
            @click="toggleFullScreen"
          >
            <SlpIcon name="minimize" variant="product" size="md" />
            <div class="popup-content">
              <p>Exit fullscreen</p>
              <div class="point"></div>
            </div>
          </button>
          <button
            type="button"
            class="btn btn__close"
            data-ga-name="exit"
            data-ga-location="demo"
            @click="close"
          >
            <SlpTypography class="btn__close-text" variant="body1-bold" tag="p">
              Exit</SlpTypography
            ><SlpIcon name="close" variant="product" class="btn__close-icon" />
          </button>
        </div>
      </header>
      <header v-show="isMobile" class="modal__header--mobile">
        <slot name="header"></slot>
        <div class="header-title">
          <SlpTypography variant="body1-bold">{{
            data.subtitle
          }}</SlpTypography>
          <button
            type="button"
            class="btn btn__close"
            data-ga-name="exit"
            data-ga-location="demo"
            @click="close"
          >
            <SlpIcon name="close" variant="product" class="btn__close-icon" />
          </button>
        </div>

        <div class="header-buttons">
          <SlpButton
            class="cta-button"
            variant="primary"
            :href="data.scheduleButton.href"
            :data-ga-name="data.scheduleButton.data_ga_name"
            :data-ga-location="data.scheduleButton.data_ga_location"
            >{{ data.scheduleButton.text }}</SlpButton
          >
        </div>
      </header>
      <section ref="videoSection" class="modal__body">
        <slot name="body"></slot>
        <lite-vimeo
          v-if="isMobile"
          :videoid="
            getVimeoVideoId(
              data.mobileVideo
                ? createVideoSource(data.mobileVideo)
                : createVideoSource(
                    'https://player.vimeo.com/video/892023806?badge=0&amp;autopause=0&amp;player_id=0&amp;app_id=58479',
                  ),
            )
          "
        ></lite-vimeo>
        <iframe
          v-else
          :src="createVideoSource(data.video.url)"
          title="YouTube video player"
          frameborder="0"
          loading="lazy"
        ></iframe>
      </section>
      <footer class="modal__footer">
        <slot name="footer"></slot>
      </footer>
    </div>
  </div>
</template>
<style lang="scss" scoped>
// pop-up modal
.modal {
  background: transparent;
  display: flex;
  flex-direction: column;
  justify-content: center;
  align-items: center;
  margin-top: 80px;
  background-color: #ffffff !important;
  border-radius: 4px;
  width: 80%;
  height: 80%;
  max-width: 1440px;
  max-height: 900px;

  &__backdrop--light {
    position: fixed;
    top: 0;
    bottom: 0;
    left: 0;
    right: 0;
    backdrop-filter: blur(2px);
    background-color: rgba($color-surface-700, 0.2);
    display: flex;
    justify-content: center;
    align-items: flex-start;
    z-index: 2000;
  }
  &__header {
    position: relative;
    justify-content: space-between;
    background-color: transparent;
    padding: 8px 16px 8px 24px;
    display: flex;
    flex-direction: row;
    width: 100%;
    color: $color-text-300;

    .header-title {
      display: flex;
      align-items: center;
    }
    .header-logo {
      display: none;
    }
  }
  &__footer {
    padding-bottom: $spacing-8;
    display: flex;
  }
  &__body {
    position: relative;
    padding: 0 $spacing-8 0 $spacing-8;
    overflow: hidden;
    width: 100%;
    height: 100%;
    iframe,
    lite-vimeo {
      width: 100%;
      height: 100%;
      border-radius: 4px;
      border: 1px solid $color-primary-100;
    }
  }
  .header-buttons {
    display: flex;
    flex-direction: row;
    align-items: center;
    justify-content: center;

    .cta-button {
      border: 1px solid $color-primary-300;
      margin-right: 16px;
      &:hover {
        border: 1px solid #171321;
      }
    }
    .btn {
      cursor: pointer;
      &__close {
        display: flex;
        justify-content: center;
        align-items: center;
        border: none;
        &:hover {
          text-decoration: underline;
          text-underline-offset: 2px;
          transition: all 0.2s ease-in-out;
        }
        .slp-icon {
          margin-left: 4px;
        }
        svg {
          width: 100%;
          height: 100%;
        }
      }
      .popup-content {
        display: none;
        position: absolute;
        background-color: $color-surface-600;
        border: 1px solid $color-surface-600;
        border-radius: 4px;
        color: $color-secondary-200;
        padding: 10px;
        top: 60px;
        box-shadow: 0px 2px 5px rgba(0, 0, 0, 0.2);
        z-index: 3000;
        &::before {
          content: '';
          position: absolute;
          top: 0;
          left: 50%;
          transform: translateX(-50%);
          width: 0;
          height: 0;
          top: -5px;
          border-left: 6px solid transparent;
          border-right: 6px solid transparent;
          border-bottom: 6px solid $color-surface-600;
        }
      }
      &__minimize {
        display: none;
      }
      &__maximize {
        display: flex;
        border: 1px solid;
        border-radius: 4px;
        background-color: $color-secondary-200;
        width: 44px;
        height: 44px;
        align-items: center;
        justify-content: center;
        margin-right: 10px;

        &:hover {
          background-color: $color-secondary-100;
          border: 1px solid $color-secondary-100;
          border-radius: 4px;
          transition: 300ms cubic-bezier(0.7, 0, 0.3, 1) background-color;
          .popup-content {
            display: block;
            transition: 300ms;
          }
        }
        .slp-icon {
          width: 20px;
          height: 20px;
        }
      }
    }
  }

  @media screen and (max-width: $breakpoint-sm) {
    width: 100%;
    height: 100%;
    margin-top: 0px;
    max-width: 100%;
    max-height: 100%;
    .modal__header--mobile {
      justify-content: space-between;
      background-color: $color-primary-200;
      padding: $spacing-16;
      display: flex;
      flex-direction: column;
      width: 100%;
      color: $color-primary-300;
    }
    .header-title {
      display: flex;
      align-items: self-start;
      margin-bottom: $spacing-8;

      .btn {
        cursor: pointer;
        &__close {
          border: none;
          padding: 10px;
          color: $color-primary-300;
          svg {
            width: 100%;
            height: 100%;
          }
          &-icon {
            margin-left: 4px;
          }
        }
      }
    }
    .modal__footer {
      display: none;
    }
    .modal__body {
      position: relative;
      overflow: hidden;
      width: 100%;
      height: 100%;
      padding: 0px;
      iframe {
        width: 100%;
        height: 100%;
      }
    }
    .header-buttons {
      display: flex;
      flex-direction: row;
      justify-content: center;
      .cta-button {
        display: flex;
        justify-content: center;
        width: 100%;
        margin-right: 0px;
      }
    }
  }
}

//fullscreen modal
.fullscreen {
  width: 100%;
  height: 100%;
  margin-top: 0px;
  max-width: 100%;
  max-height: 100%;
  .modal__header {
    justify-content: space-between;
    background-color: $color-primary-200;
    margin-bottom: 0px;
    display: flex;
    flex-direction: row;
    width: 100%;
    color: $color-primary-300;
    .header-logo {
      display: flex;
      align-items: center;
    }
  }
  .modal__footer {
    display: none;
  }
  .modal__body {
    position: relative;
    overflow: hidden;
    width: 100%;
    height: 100%;
    padding: 0px;
    iframe,
    lite-vimeo {
      width: 100%;
      height: 100%;
      border: none;
      border-radius: 0px;
    }
  }
  .header-buttons {
    display: flex;
    flex-direction: row;
    justify-content: space-between;
    .btn {
      cursor: pointer;
      &__close {
        border: none;
        padding-left: 0px;
        color: $color-primary-300;
        svg {
          width: 100%;
          height: 100%;
        }
        &-icon {
          margin-left: 4px;
        }
      }
      &__maximize {
        display: none;
      }
      &__minimize {
        display: flex;
        border: 1px solid;
        border-radius: 4px;
        background-color: $color-secondary-200;
        width: 45px;
        height: 45px;
        margin-right: 16px;
        align-items: center;
        justify-content: center;
        &:hover {
          background-color: $color-secondary-100;
          border-radius: 4px;
          transition: 300ms cubic-bezier(0.7, 0, 0.3, 1) background-color;
          .popup-content {
            display: block;
            transition: 300ms;
          }
        }
        .slp-icon {
          width: 20px;
          height: 20px;
        }
      }
    }
  }
}
</style>
